unit Log;

interface

Procedure SetLogFile(F: string);
Procedure AddtoLog(const S: string);
Procedure EndLog;

Var LastLine: string;

implementation

Uses Windows, SysUtils, Globals;

Var LogFile: string;
    TimeLapse: TTimeStamp;

Procedure SetLogFile(F: string);
Var Ff: TextFile;
    T: TDateTime;
    T2: TTimeStamp;
begin
   LogFile := F;
  try
   AssignFile(Ff, F);
   Rewrite(Ff);
   T := Time;
   T2 := DateTimeToTimeStamp(T);
   TimeLapse := T2;
   Writeln(Ff,'BOF ------------------------------');
   Writeln(Ff,'Log Started at: ', T2.Time, ' milliseconds and ', T2.Date, ' days.');
   Writeln(Ff);
   CloseFile(Ff);
  except
   MessageBox(h_wnd, 'When init''ing the log file, an error occured.', 'Error', MB_OK or MB_ICONERROR);
   CloseFile(Ff);
  end;
end;

Procedure EndLog;
Var Ff: TextFile;
    T: TDateTime;
    T2: TTimeStamp;
begin
  Try
   AssignFile(Ff, LogFile);
   Append(Ff);
   T := Time;
   T2 := DateTimeToTimeStamp(T);

   writeln(ff);
   Writeln(Ff,'Log Closed at: ', T2.Time, ' milliseconds and ', T2.Date, ' days.');
   Writeln(Ff,'Total Time: ', (T2.Time-TimeLapse.Time)/1000:0:3, ' seconds.');
   Writeln(Ff,'EOF ------------------------------');
   CloseFile(Ff);
  except
   MessageBox(h_wnd, 'When closing the log file, an error occured.', 'Error', MB_OK or MB_ICONERROR);
   CloseFile(Ff);
  end;
  
end;

Procedure AddtoLog(const S: string);
Var F: TextFile;
begin
    LastLine := S;
   try
    AssignFile(F, LogFile);
    Append(F);
    Writeln(f, S);
    CloseFile(F);
   except
    MessageBox(h_wnd, 'When writing to the log file, a non-fatal error occured.', 'Error', MB_OK or MB_ICONWARNING);
    Closefile(F);
   end;
end;

end.
