{-----------------------------------------------------------------------------
 Unit Name: Skybox
 Author:    Nitrogen
 Purpose:   Provides a window to the heavens together with a nifty lens flare..
 History:   Created 22 July
-----------------------------------------------------------------------------}


unit Skybox;

interface

Uses OpenGL, TGATexture, Log, Globals;


var SkyboxDL: gluint;
    Sun: array[0..2] of glDouble;

Procedure InitSkybox;
Procedure CreateSkybox(S: single);
Procedure GetFlarePos(Var sx, sy, sz: glDouble; var Col: boolean);

implementation

var Sky: array[0..4] of gluint;

Procedure InitSkybox;
begin
    LoadJpg('Data\Skybox\Front.jpg', Sky[0]);
    LoadJpg('Data\Skybox\Right.jpg', Sky[1]);
    LoadJpg('Data\Skybox\Back.jpg', Sky[2]);
    LoadJpg('Data\Skybox\Left.jpg', Sky[3]);
    LoadJpg('Data\Skybox\Top.jpg', Sky[4]);


end;

Procedure CreateSkybox(S: single);
Var Seam: single;
begin
   Seam := 0.004;
   SkyboxDl := glGenLists(1);
   glNewList(SkyboxDl, GL_COMPILE);
   glTranslatef(0,S/1.5,0);
   glbindTexture(GL_TEXTURE_2D, Sky[0]);
   glBegin(GL_TRIANGLE_STRIP);
     glTexCoord2f(0+seam, 1-seam);  glVertex3f(-S, S,-S);
     glTexCoord2f(0+seam, 0+seam);  glVertex3f(-s,-S,-S);

     glTexCoord2f(1-seam, 1-seam); glVertex3f( s, s,-s);
     glTexCoord2f(1-seam, 0+seam); glVertex3f( s,-s,-s);
   glEnd;

   glbindTexture(GL_TEXTURE_2D, Sky[1]);
    glBegin(GL_TRIANGLE_STRIP);
     glTexCoord2f(0+seam, 1-seam); glVertex3f( s, s,-s);
     glTexCoord2f(0+seam, 0+seam); glVertex3f( s,-s,-s);

     glTexCoord2f(1-seam, 1-seam);  glVertex3f( s, s, s);
     glTexCoord2f(1-seam, 0+seam);  glVertex3f( s,-s, s);
   glEnd;


   glbindTexture(GL_TEXTURE_2D, Sky[2]);
   glBegin(GL_TRIANGLE_STRIP);
     glTexCoord2f(0+seam, 1-seam);  glVertex3f( s, s, s);
     glTexCoord2f(0+seam, 0+seam);  glVertex3f( s,-s, s);

     glTexCoord2f(1-seam, 1-seam); glVertex3f(-s, s, s);
     glTexCoord2f(1-seam, 0+seam); glVertex3f(-s,-s, s);
    glEnd;

   glbindTexture(GL_TEXTURE_2D, Sky[3]);
    glBegin(GL_TRIANGLE_STRIP);
     glTexCoord2f(0+seam, 1-seam); glVertex3f(-s, s, s);
     glTexCoord2f(0+seam, 0+seam); glVertex3f(-s,-s, s);

     glTexCoord2f(1-seam, 1-seam);  glVertex3f(-s, s,-s);
     glTexCoord2f(1-seam, 0+seam);  glVertex3f(-s,-s,-s);
    glEnd;

    sEam := Seam /3;
    glbindTexture(GL_TEXTURE_2D, Sky[4]);
    glBegin(GL_QUADS);
     glTexCoord2f(0+seam,   0+seam);  glVertex3f(-s,s,-s);
     glTexCoord2f(1-seam,   0+seam);  glVertex3f( s,s,-s);
     glTexCoord2f(1-seam,   1-seam);  glVertex3f( s,s, s);
     glTexCoord2f(0+seam,   1-seam);  glVertex3f(-s,s, s);

    { glTexCoord2f(0.5+seam,1-seam);  glVertex3f(-s,-s,-s);
     glTexCoord2f(1.0-seam,1-seam);  glVertex3f( s,-s,-s);
     glTexCoord2f(1.0-seam,0+seam);  glVertex3f( s,-s, s);
     glTexCoord2f(0.5+seam,0+seam);  glVertex3f(-s,-s, s);
    }
    glEnd;
   glEndList;
end;


Procedure GetFlarePos(Var sx, sy, sz: glDouble; var Col: boolean);
Var
    modelMatrix: array[0..15] of glDouble; // The model matrix.
    projMatrix: array[0..15] of glDouble;  // The projection matrix.
    viewport: array[0..3] of glint;        // The viewport.
    Depth: glFloat;
begin


    glGetDoublev(GL_MODELVIEW_MATRIX, @modelMatrix); // Load the matricies and viewport.
    glGetDoublev(GL_PROJECTION_MATRIX, @projMatrix);
    glGetIntegerv(GL_VIEWPORT, @viewport);

    gluProject(sun[0],sun[1],sun[2],@modelMatrix,@projMatrix,@viewport,sx,sy,sz); // Find out where the light is on the screen.

    Col := True;
    if(sx < viewport[2]) and (sx >= 0) and
    (sy < (viewport[3]+Startupinfo.Wid/18)) and (sy >= 20)  then
    begin
       glReadPixels(round(sx),round(sy),1,1,GL_DEPTH_COMPONENT,GL_FLOAT,@depth);
       if(depth < sz) then // but it is behind something.
         Col := False; // The light can't be seen.

    end
    else // If the light isn't on the screen
    Col := False; // The light can't be seen.


end;

end.
