//Startup unit, for displaying log and display settings...

unit Startup;

interface

uses Windows, OpenGL12, Globals, TGATexture, Font, Log, Sound, Octtree, Engine;

Procedure Startup_init;
Procedure Startup_loop;
Procedure Startup_Unload;

Var
   EverythingOK: boolean = true;
   Halted: boolean = false;
implementation

Uses Sysutils;

Const
     endLog = 32;

type
    RGB=record
        R,G,B: single;
        end;

Var 
    Fx, Tx: array[0..6] of single;
    Lim: array[1..3] of integer;
    PF, NF: single;
    Sel, LSel: integer;
    Sel2: array[1..3] of integer;

    MenuTex1: gluInt;
    LogoTex: gluint;

    Logging, Ready: boolean;
    Logg: array[0..17] of string;
    LogProgress: integer;
    LogCol: array[0..17] of RGB;

Procedure Add(S: string; R,G,B: single); forward;
Procedure DoLog(l: integer); forward;


Procedure SaveStuff;
Var F: file of integer;
begin
 Try
  Assignfile(F, ExePath+'\Config.cfg');
  Rewrite(F);
  Write(F, Sel2[1], Sel2[2], Sel2[3]);
  CloseFile(F);
 except
  Messagebox(0, 'Could Not Save Config to file', 'Error', MB_OK or MB_ICONERROR);
 end;

end;

Procedure LoadStuff;
Var F: file of integer;
begin
 Try
  Assignfile(F, ExePath+'\Config.cfg');
  Reset(F);
  Read(F, Sel2[1], Sel2[2], Sel2[3]);
  CloseFile(F);
 except
  Messagebox(0, 'This is the first time you have run this demo.'+#13+'Please choose your screen setting by using the menus:'+#13+'The left and right arrow keys navigate the menus,'+#13+' while up and down change the selection.', 'First Run', MB_OK or MB_ICONINFORMATION);
 end;
end;

Procedure Startup_init;
begin
   Addtolog('Startup INIT');
   glEnable(GL_TEXTURE_2D);
   glEnable(GL_BLEND);
   glDisable(GL_DEPTH_TEST);
   glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
   F.Load(ExePath+'\Data\font.fnt');

   Logging := False;
   Ready := false;

   LoadJpg(ExePath+'\Data\Logo.jpg',  LogoTex);
   LoadTga(ExePath+'\Data\Menu.tga',  MenuTex1, False);

   Tx[0] := 122;
   Fx[0] := -1000;
   Tx[1] := 55;
   Fx[1] := -2000;
   Tx[2] := 55+130;
   Fx[2] := -2000;
   Tx[3] := 55+130*2;
   Fx[3] := -2000;
   Tx[4] := 120;
   Fx[4] := -2000;
   Tx[5] := 120+130;
   Fx[5] := -2000;
   Tx[6] := -2000;
   Fx[6] := -2000;
   Sel := 1;

   Sel2[1] := 1;
   Sel2[2] := 1;
   Sel2[3] := 1;

   LoadStuff;

   Lim[1] := 3;
   Lim[2] := 2;
   Lim[3] := 3;

end;

Procedure DrawQuadM(X,Y,W,H, L,Xx,Yy,Xx2,Yy2: glFloat);
begin

   glBegin(GL_QUADS);
       glTexCoord2f(0,1);glVertex3f(X+xx,    Y+yy,     -L);
       glTexCoord2f(1,1);glVertex3f(X+W+xx2, Y+yy,     -L);
       glTexCoord2f(1,0);glVertex3f(X+w+xx2, Y-H+yy2,   -L);
       glTexCoord2f(0,0);glVertex3f(X+xx,    Y-H+yy2,   -L);
   glEnd;
end;

Procedure DrawQuadC(X,Y,W,H, L,Tint,Alpha,Tu, Tv, Tu2, Tv2: glFloat);
begin
   glBegin(GL_QUADS);
     Tv := 256-Tv;
     Tv2 := 256-Tv2;
       glColor4f(Tint,Tint,Tint, Alpha);
       glTexCoord2f(tu/256,tv/256);glVertex3f(X,    Y,     -L);
       glTexCoord2f(tu2/256,tv/256);glVertex3f(X+W,  Y,     -L);
       glTexCoord2f(tu2/256,tv2/256);glVertex3f(X+W,  Y-H,   -L);
       glTexCoord2f(tu/256,tv2/256);glVertex3f(X,    Y-H,   -L);
   glEnd;
end;

Procedure Startup_Unload;
begin
   Addtolog('Startup Unload');
  if GL_VERSION_1_2 then
  begin
   glDeleteTextures(1, @F.TexInd);
   glDeleteTextures(1, @LogoTex);
   glDeleteTextures(1, @MenuTex1);
  end;
   SwitchView(False);
end;


Procedure StartLog;
Var I: integer;
begin
  LogProgress := 0;
  Logging := false;
  Ready := false;
   For I := 0 to 5 do
   Tx[I] := SetupWidth+100;

   Tx[6] := 0;
   for I := 0 to 17 do
   begin
      Logg[I] := '';
      LogCol[i].R := 1;
      LogCol[i].G := 1;
      LogCol[i].B := 1;
   end;
end;

Procedure ChangeScreen;
begin
       Case Sel2[1] of
       1:
       begin
         Startupinfo.Wid := 640;
         Startupinfo.Hgt := 480;
       end;
       2:
       begin
         Startupinfo.Wid := 800;
         Startupinfo.Hgt := 600;
       end;
       3:
       begin
         Startupinfo.Wid := 1024;
         Startupinfo.Hgt := 768;
       end;
       end;
       Case Sel2[2] of
       1:
       begin
         Startupinfo.Bpp := 16;
       end;
       2:
       begin
         Startupinfo.Bpp := 32;
       end;
       end;
       Case Sel2[3] of
       1:
       begin
         Startupinfo.Res := 75;
       end;
       2:
       begin
         Startupinfo.Res := 85;
       end;
       3:
       begin
         Startupinfo.Res := 100;
       end;
       end;
       Startupinfo.Fullscreen:= True;
    Stage := -1;
end;

Procedure Processkeys;
begin
  if Keys[VK_LEFT] then
  begin
   Keys[VK_LEFT] := False;
   if Sel > 1 then
   begin
     LSel := Sel;
     dec(Sel);
     Pf := 1;
     Nf := 0;
   end;
  end;
  if Keys[VK_RIGHT] then
  begin
   Keys[VK_RIGHT] := False;
   if Sel < 5 then
   begin
     LSel := Sel;
     inc(Sel);
     Pf := 1;
     Nf := 0;
   end;
  end;

  if Keys[VK_UP] then
  begin
   Keys[VK_UP] := False;
   if Sel2[sel] > 1 then
   begin
      dec(Sel2[sel]);
   end;

  end;
  if Keys[VK_DOWN] then
  begin
   Keys[VK_DOWN] := False;
   if Sel2[sel] < Lim[Sel] then
   begin
      inc(Sel2[sel]);
   end;

  end;

  if Keys[13] then
  begin
   Keys[13] := False;
   case Sel of
   4: begin
       SaveStuff;

       StartLog;
      end;
   5: Finished := True;
   end;

  end;


end;

function Settings: string;
begin
    Result := '';
    Case Sel2[1] of
    1: Result := Result+'640x480 - ';
    2: Result := Result+'800x600 - ';
    3: Result := Result+'1024x768 - ';
    end;
    Case Sel2[2] of
    1: Result := Result+'16 Bits - ';
    2: Result := Result+'32 Bits - ';
    end;
    Case Sel2[3] of
    1: Result := Result+'75 Hz ';
    2: Result := Result+'85 Hz ';
    3: Result := Result+'100 Hz ';
    end;

end;


Procedure Startup_loop;
Var I: integer;
    O, R,G,B: single;
    T: GLFLoat;
begin
   ProcessKeys;
   SwitchView(True);

   glEnable(GL_TEXTURE_2D);
   glBlendfunc(GL_ONE, GL_ONE);
   glBindTexture(GL_TEXTURE_2D, LogoTex);

   T := Sin(ElapsedTime/2000)*2+sin(ElapsedTime/2300)*1;

   glColor3f(0.1,0.1,0.1);
   DrawQuadM(HSW-128,HSH+110,256,256,2, 0,0,0,0);

   For I := 1 to 5 do
   begin
     glcolor3f(1/5, 1/5, 1/5);
     DrawQuadM(HSW-128-I*T,HSH+110+I*T,256+I*2*T,256+I*2*T,2, 0,0,0,0);
   end;


   glBlendfunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

   if Nf < 1 then Nf := Nf+(1-Nf)/50+0.001;
   if Pf > 0 then Pf := Pf+(0-Pf)/50+0.001;


   For I := 0 to 5 do
   if Fx[i] < Tx[i] then Fx[i] := Fx[i] + (Tx[i]-Fx[i])/(60*(I+1)/2.5) +0.01;
   if Fx[6] < Tx[6] then Fx[6] := Fx[6] + (Tx[6]-Fx[6])/35+0.01;

   if (logging = false) and (Fx[6] > -1000) then
    begin
     if Fx[6] >= -1 then begin Logging := true; Ready := true; end;
    end;

   if Ready and not Halted then
   begin
    Inc(LogProgress);
    if LogProgress >= EndLog then Ready := false;
    DoLog(LogProgress);
   end;


   O := Sin(elapsedTime/150)*0.2;
   glBindTexture(GL_TEXTURE_2D, MenuTex1);
   DrawQuadC(Fx[0]-5,  400, 256, 60, 2, 1,1,0,198,256,252);

   if Sel = 1 then R := 0.7+o else R := 1;
   DrawQuadC(Fx[1]-15, 330, 140, 44, 2, 1,R,0,0,140,44);
   if Sel = 1 then R := NF else if LSel = 1 then R := Pf else R := 0;
   DrawQuadC(Fx[1]-15, 330-44, 140, 132*R, 2, 1,R,0,44,140,175);

   if Sel = 2 then R := 0.7+o else R := 1;
   DrawQuadC(Fx[2]-15, 330, 140, 44, 2, 1,R,0,0,140,44);
   if Sel = 2 then R := NF else if LSel = 2 then R := Pf else R := 0;
   DrawQuadC(Fx[2]-15, 330-44, 140, 132*R, 2, 1,R,0,44,140,175);

   if Sel = 3 then R := 0.7+o else R := 1;
   DrawQuadC(Fx[3]-15, 330, 140, 44, 2, 1,R,0,0,140,44);
   if Sel = 3 then R := NF else if LSel = 3 then R := Pf else R := 0;
   DrawQuadC(Fx[3]-15, 330-44, 140, 132*R, 2, 1,R,0,44,140,175);

   if Sel = 4 then R := 0.7+o else R := 1;
    DrawQuadC(Fx[4]-15, 80, 140, 44, 2, 1,R,0,0,140,44);

   if Sel = 5 then R := 0.7+o else R := 1;
    DrawQuadC(Fx[5]-15, 80, 140, 44, 2, 1,R,0,0,140,44);

   if Fx[6] > -1000 then
   begin

     DrawQuadC(Fx[6], SetupHeight-10, SetupWidth-20, SetupHeight-20, 2, 1,1,0,44,140,175);

     glBindTexture(GL_TEXTURE_2D, F.TexInd);

     For I := 0 to 17 do
     begin
        glColor3f(LogCol[I].R,LogCol[I].G,LogCol[I].B);
        F.Draw(Fx[6]+90, SetupHeight-20-I*20, Logg[I], 1);
     end;
   end;

     glBindTexture(GL_TEXTURE_2D, F.TexInd);

   if Sel = 4 then R := NF else if LSel = 4 then R := Pf else R := 0;
   if ((Sel = 4) or (LSel=4)) and (Fx[6] < -1000) then
   begin
    glColor4f(1,1,1,R);
    f.Draw(250-F.TextLen(Settings)/2, 30, Settings, 1);
   end;

   if Sel = 3 then R := NF else if LSel = 3 then R := Pf else R := 0;
   if (Sel = 3) or (LSel=3) then
   begin
    glColor4f(1,1,0,R);
    f.Draw(250-F.TextLen('Note: Not all computers support these settings')/2, 30, 'Note: Not all computers support these settings', 1);
   end;

   glColor3f(1,1,1);
   glbindTexture(GL_TEXTURE_2D, F.TexInd);
   F.Draw(Fx[0]+35,  400-17,'THE FOUNDRY - Setup', 1);
   F.Draw(Fx[1]+20,  330-13,'SIZE', 1);
   F.Draw(Fx[2]+20,  330-13,'DEPTH', 1);
   F.Draw(Fx[3]+20,  330-13,'REFRESH', 1);

   F.Draw(Fx[4]+20,  80-13,'GO', 1);
   F.Draw(Fx[5]+20,  80-13,'CANCEL', 1);

   R:=Nf+o;
   G:= Nf*0.1+o;
   B:=0.3+o;
   if Sel in [1..3] then
   begin
     Case Sel of
     1:
       begin
          if Sel2[1] = 1 then glColor3f(r,g,b) else glColor3f(nf,nf,nf);
          f.Draw(Fx[1]+19, 260, '640x480', 1);
          if Sel2[1] = 2 then glColor3f(r,g,b) else glColor3f(nf,nf,nf);
          f.Draw(Fx[1]+19, 230, '800x600', 1);
          if Sel2[1] = 3 then glColor3f(r,g,b) else glColor3f(nf,nf,nf);
          f.Draw(Fx[1]+19, 200, '1024x768', 1);
       end;
     2:
       begin
          if Sel2[2] = 1 then glColor3f(r,g,b) else glColor3f(nf,nf,nf);
          f.Draw(Fx[2]+19, 260, '16 Bit', 1);
          if Sel2[2] = 2 then glColor3f(r,g,b) else glColor3f(nf,nf,nf);
          f.Draw(Fx[2]+19, 230, '32 Bit', 1);
       end;
     3:
       begin
          if Sel2[3] = 1 then glColor3f(r,g,b) else glColor3f(nf,nf,nf);
          f.Draw(Fx[3]+19, 260, '75 Hz', 1);
          if Sel2[3] = 2 then glColor3f(r,g,b) else glColor3f(nf,nf,nf);
          f.Draw(Fx[3]+19, 230, '85 Hz', 1);
          if Sel2[3] = 3 then glColor3f(r,g,b) else glColor3f(nf,nf,nf);
          f.Draw(Fx[3]+19, 200, '100 Hz', 1);
       end;

     end;
   end;

   SwitchView(False);
end;

function CheckFileExists(F: string): boolean;
Var S: TSearchRec;
begin
    Result := false;
    if FindFirst(F, faAnyFile, S) = 0 then
    begin
      Result := True;
      Add('File ' + ExtractFilename(F) + ': OK', 0, 1, 0);
    end;
     if Result = false then
      Add('File ' + ExtractFilename(F) + ': NOT FOUND', 1, 0.2, 0);
    FindClose(S);
    if Result = false then EverythingOK := false;
end;

Procedure DoLog(l: integer);
begin
if (l > 1) and (EverythingOK = false) then L := EndLog;
case l of
1:
   EverythingOK := True;
2:  Add('Starting Log...', 1, 1, 1);
3:  Add('', 1,1,1);
4:  Add('Reading Extensions...', 1,1,1);
5:  ReadExtensions;
6:  if @glActiveTextureARB <> nil then
    Add('Multitexturing ENABLED!', 0.9, 0.9, 0.9) else
    begin
     Add('Multitexturing Not Avaliable! Cannot Proceed.', 1, 0, 0);
     EverythingOK := false;
    end;



7:  Add('Checking Necessary Files...',1,1,1);
8:  CheckFileExists('fmod.dll');
10: begin
      glActiveTextureARB(GL_TEXTURE0_ARB);
      glEnable(GL_TEXTURE_2D);
      glActiveTextureARB(GL_TEXTURE1_ARB);
      glEnable(GL_TEXTURE_2D);
      glActiveTextureARB(GL_TEXTURE0_ARB);



      if GL_VERSION_1_2 then
        Add('You have OpenGL version 1.2...', 0,1,0.2)
      else
      if GL_VERSION_1_1 then
        Add('You have OpenGL version 1.1...', 1,1,0)
      else
      if GL_VERSION_1_0 then
        Add('You have OpenGL version 1.0...', 1,0.4,0.2);


       Add('', 1,1,1);
       Add('Initalising Sound Output...', 1,1,1);
       InitSound;
    end;

11:  if SoundEnabled then
      begin
        Add('FMOD Started OK!', 0, 1, 0.4);
        Add('Loading Music Stream...', 1, 1, 1);
        if Music.Load('Data\Foundry.mus') then
         Add('Music was successfully loaded.', 0, 0.5, 1)
         else
        Add('There was an error loading the music. Music will not be played.', 1, 0.5, 0);
      end
      else
      begin
        Add('There was an error starting FMOD,', 1, 0.5, 0);
        Add('Sound will be disabled.', 1, 0.5, 0);
      end;

12:begin
      Add('',1,1,1);
     CheckFileExists('data\Air.ppl');
   end;

13: begin
     CheckFileExists('data\T4e.ppl');
     CheckFileExists('data\Water.ppl');
     CheckFileExists('data\Fire.ppl');
     CheckFileExists('data\Earth.ppl');
    end;
15: begin
      add('', 1,1,1);
      Add('Checking Vital Files:', 1, 1, 1);
      CheckFileExists('Data\First.hybd');
      CheckFileExists('Data\Main.hybd');
    end;
EndLog: begin  Add('Startup Complete.', 0.2,0.6,1);

     if EverythingOK then begin ChangeScreen; end else begin Add('System Halted. Press ESC to exit.', 1, 0.5, 0); Halted := true; end;

    end;
end; //Case
end;

Procedure Add(S: string; R,G,B: single);
Var I: integer;
begin

    AddtoLog(S);
    For I := 1 to 17 do
    begin
      Logg[I-1] := Logg[I];
      LogCol[I-1] := LogCol[I];
    end;
      Logg[17] := S;
      LogCol[17].R  :=R;
      LogCol[17].G  :=G;
      LogCol[17].B  :=B;


end;


end.
